
var CarChooseLayer = cc.Layer.extend({
	sprite_background:null,
	
    arry_carband_sequence:null,
    
    sprite_car_name:null,
    car_name_begin_position:null,
    
    arry_sprite_cars:null,
    
    arry_car_begin_position:null,
    
    band_begin_position:null,
    band_end_position:null,
    
    arry_right_flag_position:null,
     
    label_step:null,
    
    right_index:null,
    
    sprite_monkey:null,
    monkey_begin_position:null,
    monkey_mid_position:null,
    monkey_end_position:null,

    sprite_monkey_success:null,
    
    sprite_state:null,
                                     
    menu_item_replay:null,
                                     
    sprite_listener0:null,
    sprite_listener1:null,
    sprite_listener2:null,
    sprite_listener3:null,
    
    n_cur_step:null,
            
    menu_turn:null,
                                     
    star_ad:null,
                                    
    
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        this._super();
        var self = this;
        cc.eventManager.addListener({
        	event: cc.EventListener.KEYBOARD,
        	onKeyReleased: function(keyCode, event) {
        		if (keyCode == cc.KEY.back) {
        			ddStopAllEffect();
        			cc.director.popScene();
                    self.cleanScene();
        		}
        		else if (keyCode == cc.KEY.menu) {

        		}
        	}}, this);
        
        var size = cc.winSize;
                                    
        this.initConfig();
                                      
        this.sprite_background = new cc.Sprite("res/game3/background.jpg");
        this.sprite_background.x = size.width / 2;
        this.sprite_background.y = size.height / 2;
        this.sprite_background.scaleX = widthRatio;
        this.addChild(this.sprite_background, 0);
        
        this.sprite_car_name = new cc.Sprite(getCNamePath(this.arry_carband_sequence[this.n_cur_step]));
        this.sprite_car_name.x = this.car_name_begin_position.x;
        this.sprite_car_name.y = this.car_name_begin_position.y;
        this.sprite_car_name.scale = 0.7;
        this.sprite_car_name.opacity = 0;
        this.addChild(this.sprite_car_name, 3);
                                     
        this.arry_sprite_cars = [null, null, null, null];
        for(var n_index = 0; n_index < 4; ++n_index){
        	this.arry_sprite_cars[n_index] = new CarSprite(getNormalPath(this.arry_carband_sequence[this.n_cur_step]));
            this.arry_sprite_cars[n_index].x = this.arry_car_begin_position[n_index].x;
            this.arry_sprite_cars[n_index].y = this.arry_car_begin_position[n_index].y;
            this.arry_sprite_cars[n_index].scale = 1;
            this.arry_sprite_cars[n_index].opacity = 0;
            this.addChild(this.arry_sprite_cars[n_index], 5 + n_index);
        }
                                     
        var arry_menu_item = [];
        var backItem = new cc.MenuItemImage(
        		"res/RetBtnNormal.png",
        		"res/ReturnBtnHigh.png",
        		function () {
                    ddStopAllEffect();
                    cc.director.popScene();
                    self.cleanScene();
        		}, this);
        backItem.attr({
        	x: isFullScreenDevice()?170:70,
        	y: size.height - 70,
        	anchorX: 0.5,
        	anchorY: 0.5
        });
        arry_menu_item[0] = backItem;
                                     
        this.menu_item_replay = new cc.MenuItemImage(
            "res/RetryBtnNormal.png",
            "res/RetryBtnHigh.png",
            function () {
                ddStopAllEffect();

                this.initConfig();
                this.sprite_monkey_success.stopAllActions();
                this.sprite_monkey_success.setVisible(false);
                this.menu_item_replay.setVisible(false);
                this.reshuffleGame();
        }, this);
        this.menu_item_replay.attr({
            x: size.width / 2,
            y: 120,
            anchorX: 0.5,
            anchorY: 0.5
        });
        arry_menu_item[1] = this.menu_item_replay;
        this.menu_item_replay.setVisible(false);
                                     
        var menu = new cc.Menu(arry_menu_item);
        menu.x = 0;
        menu.y = 0;
        this.addChild(menu, 10);
        
        this.label_step = new cc.LabelTTF("49/49", "Arial", "30");
        this.label_step.x = size.width - 115;
        this.label_step.y = size.height - 57;
        this.label_step.setColor(cc.color(255, 0, 0, 1));
        this.addChild(this.label_step, 11);
        
        this.sprite_state = new cc.Sprite("res/game3/right.png");;
        this.sprite_state.x = size.width / 2 - 165;
        this.sprite_state.y = size.height / 2 - 110;
        this.sprite_state.setVisible(false);
        this.addChild(this.sprite_state, 12);
        
        this.sprite_right_flag = new cc.Sprite("res/game3/right_flag.png");
        this.sprite_right_flag.x = size.width / 2;
        this.sprite_right_flag.y = size.height / 2;
        this.sprite_right_flag.opacity = 0;
        this.addChild(this.sprite_right_flag, 13);
                                     
        this.sprite_monkey = new cc.Sprite("res/game3/car.png");
        this.sprite_monkey.x = this.monkey_begin_position.x;
        this.sprite_monkey.y = this.monkey_begin_position.y;
        this.sprite_monkey.setVisible(true);
        this.addChild(this.sprite_monkey, 14);
        
        this.sprite_monkey_success = new cc.Sprite("res/game1/wave/1.png");
        this.sprite_monkey_success.x = size.width / 2;
        this.sprite_monkey_success.y = size.height/ 2;
        this.sprite_monkey_success.setVisible(false);
        this.addChild(this.sprite_monkey_success, 16);
                                     
        var sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
              
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                  
                if (cc.rectContainsPoint(rect, locationInNode)) {
                	if (self.isSpriteShouldDraw(target)) {
                		self.pauseAllTarget();
                		ddPlayEffect('', "res/sound/right.mp3", false);
                		var n_index = -1;
                		for(var temp_index = 0; temp_index < self.arry_sprite_cars.length; ++temp_index){
                			if (target == self.arry_sprite_cars[temp_index]) {
								n_index = temp_index;
							}
                		}
                		self.sprite_right_flag.x = self.arry_right_flag_position[n_index].x;
                		self.sprite_right_flag.y = self.arry_right_flag_position[n_index].y;
                		self.sprite_right_flag.runAction(cc.fadeTo(0.1, 255));
                		
                		self.sprite_state.setTexture("res/game3/right.png");
                		self.sprite_state.setVisible(true);
                		
                		self.showCarAnimation(0);
                	} else {
                		ddPlayEffect('', "res/sound/wrong.mp3", false);
                		self.sprite_state.setTexture("res/game3/wrong.png");
                		self.sprite_state.setVisible(true);
                	}
                    return false;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
                
            },
            onTouchEnded: function (touch, event) {
                
            }
        });

        this.sprite_listener0 = sprite_listener.clone();
        this.sprite_listener0.retain();
        this.sprite_listener1 = sprite_listener.clone();
        this.sprite_listener1.retain();
        this.sprite_listener2 = sprite_listener.clone();
        this.sprite_listener2.retain();
        this.sprite_listener3 = sprite_listener.clone();
        this.sprite_listener3.retain();

        this.reshuffleGame();
                                     
        if(ARRY_AD_IN && ARRY_AD_IN.length){
            if(AD_ENABLE){
                showStarAd(this, this.star_ad, cc.p(60, -20));
            }
        }
        
        return true;
    },
                                     
    reshuffleGame:function(){
//    	if(this.n_cur_step >= 10){
        if(this.n_cur_step >= this.arry_carband_sequence.length){
        	this.showSuccessAnimation();
            return;
        }
    	
        this.sprite_monkey_success.setVisible(false);
        
    	this.right_index = -1;
    	this.sprite_car_name.opacity = 0;
    	this.sprite_right_flag.opacity = 0;
    	this.sprite_state.setVisible(false);
        
        var arry_cars_temp = this.arry_carband_sequence.slice(0);
        arry_cars_temp.splice(this.n_cur_step, 1);
        arry_cars_temp.reshuffle();
        arry_cur_cars = [this.arry_carband_sequence[this.n_cur_step], arry_cars_temp[0], arry_cars_temp[1], arry_cars_temp[2]];
        arry_cur_cars.reshuffle();
        for(var n_index = 0; n_index < 4; ++n_index){
            this.arry_sprite_cars[n_index].setTexture(getNormalPath(arry_cur_cars[n_index]));
            this.arry_sprite_cars[n_index].setCarName(arry_cur_cars[n_index]);
            this.arry_sprite_cars[n_index].x = this.arry_car_begin_position[n_index].x;
            this.arry_sprite_cars[n_index].y = this.arry_car_begin_position[n_index].y;
            this.arry_sprite_cars[n_index].scale = 0.5;
            this.arry_sprite_cars[n_index].opacity = 0;
            this.arry_sprite_cars[n_index].setVisible(true);
        }
        
        this.sprite_monkey.x = this.monkey_begin_position.x;
        this.sprite_monkey.y = this.monkey_begin_position.y;
        
        this.label_step.setString((this.n_cur_step + 1) + "/" + this.arry_carband_sequence.length);
        
        ddPlayEffect('', getCSoundPath(this.arry_carband_sequence[this.n_cur_step]), false);
        
        this.sprite_car_name.setTexture(getCNamePath(this.arry_carband_sequence[this.n_cur_step]));
        this.sprite_car_name.runAction(cc.fadeTo(0.1, 255));
        this.arry_sprite_cars[0].runAction(cc.FadeTo(0.3, 255));
        this.arry_sprite_cars[1].runAction(cc.FadeTo(0.3, 255));
        this.arry_sprite_cars[2].runAction(cc.FadeTo(0.3, 255));
        this.arry_sprite_cars[3].runAction(cc.Sequence.create(cc.FadeTo(0.4, 255), cc.CallFunc.create(function(){
            this.resumeAllTarget();
        }.bind(this))));
    },
    initConfig:function(){
        var size = cc.winSize;
        this.n_cur_step = 0;
        this.right_index = -1;
        this.arry_carband_sequence = getCarArray();
        this.arry_carband_sequence.reshuffle();
        this.arry_car_begin_position = [cc.p(size.width / 8 + 26, size.height / 2 + 75),
                                        cc.p(size.width * 3 / 8 + 5, size.height / 2 + 75),
                                        cc.p(size.width * 5 / 8 - 15, size.height / 2 + 75),
                                        cc.p(size.width * 7 / 8 - 25, size.height / 2 + 75)];
        var gap = 85;
        this.arry_right_flag_position = [cc.p(size.width / 8 + 26 + gap, size.height / 2 + 75 - gap),
                                         cc.p(size.width * 3 / 8 + 5 + gap, size.height / 2 + 75 - gap),
                                         cc.p(size.width * 5 / 8 - 15 + gap, size.height / 2 + 75 - gap),
                                         cc.p(size.width * 7 / 8 - 25 + gap, size.height / 2 + 75 - gap)];
        this.car_name_begin_position = cc.p(size.width * 2 / 3, size.height - 60);
        
        this.monkey_begin_position = cc.p(size.width + 120, 120);
        this.monkey_mid_position = cc.p(size.width / 2 + 20, 120);
        this.monkey_end_position = cc.p(-120, 120);
        
        this.band_begin_position = cc.p(size.width / 2 + 95, 110);
        this.band_end_position = cc.p(-55, 110);
                                     
    },
    isSpriteShouldDraw:function(sprite_target){
        if (sprite_target.getCarName() == this.arry_carband_sequence[this.n_cur_step]) {
            return true;
        }
    
        return false;
    },
    
    pauseAllTarget:function(){
        cc.eventManager.removeListener(this.sprite_listener0);
        cc.eventManager.removeListener(this.sprite_listener1);
        cc.eventManager.removeListener(this.sprite_listener2);
        cc.eventManager.removeListener(this.sprite_listener3);
    },
    resumeAllTarget:function(){
        cc.eventManager.addListener(this.sprite_listener0, this.arry_sprite_cars[0]);
        cc.eventManager.addListener(this.sprite_listener1, this.arry_sprite_cars[1]);
        cc.eventManager.addListener(this.sprite_listener2, this.arry_sprite_cars[2]);
        cc.eventManager.addListener(this.sprite_listener3, this.arry_sprite_cars[3]);
    },
    showSuccessAnimation:function(){
    	
    	this.arry_sprite_cars[0].opacity = 0;
    	this.arry_sprite_cars[1].opacity = 0;
    	this.arry_sprite_cars[2].opacity = 0;
    	this.arry_sprite_cars[3].opacity = 0;
    	
    	this.sprite_state.setVisible(false);
    	
    	ddPlayEffect('', "res/sound/success.mp3", false);
    	
    	this.menu_item_replay.setVisible(true);
    	
        this.sprite_monkey_success.setVisible(true);
        var animal_animation = new cc.Animation.create();
        animal_animation.setDelayPerUnit(0.05);
        animal_animation.setRestoreOriginalFrame(true);
        for(var index = 1; index < 18; ++index){
            animal_animation.addSpriteFrameWithFile("res/game1/wave/" + index + ".png");
        }
        
        var animation_blind = new cc.Animation.create();
        animation_blind.setDelayPerUnit(0.05);
        animation_blind.setRestoreOriginalFrame(true);
        for(var index = 1; index < 19; ++index){
        	animation_blind.addSpriteFrameWithFile("res/game1/blind/" + index + ".png");
        }
        this.sprite_monkey_success.runAction(cc.RepeatForever.create(cc.Sequence.create(cc.Animate.create(animation_blind), cc.Animate.create(animal_animation))));
    },
    showCarAnimation:function(step){
    	switch (step) {
		case 0:
		{
			this.scheduleOnce(function() {
				ddPlayEffect('', "res/sound/leave.mp3", false);
			}, 0.8);
			
			this.sprite_monkey.runAction(cc.Sequence.create(cc.DelayTime.create(0.5), cc.moveTo(1.3, this.monkey_mid_position).easing(cc.easeInOut(3)), 
					cc.DelayTime.create(0.3), 
					cc.CallFunc.create(function() {
						this.showBandAnimation();
					}.bind(this))));
			break;
		}
		case 1:
		{
			this.scheduleOnce(function() {
				ddPlayEffect('', "res/sound/leave.mp3", false);
			}, 0.3);
			this.sprite_monkey.runAction(cc.moveTo(1.3, this.monkey_end_position).easing(cc.easeInOut(3)));
			this.arry_sprite_cars[this.right_index].runAction(cc.Sequence.create(cc.moveTo(1.3, this.band_end_position).easing(cc.easeInOut(3)),
					cc.DelayTime.create(0.5),
					cc.CallFunc.create(function() {
						this.n_cur_step++;
						this.reshuffleGame();
					}.bind(this))));
			break;
		}
		default:
			break;
		}
    },
    showBandAnimation:function(){
    	for (var index = 0; index < this.arry_sprite_cars.length; index++) {
    		if (this.arry_sprite_cars[index].getCarName() == this.arry_carband_sequence[this.n_cur_step]) {
    			this.right_index = index;
    			var right_band = this.arry_sprite_cars[index];
    			ddPlayEffect('', "res/sound/drop.mp3", false);
    			right_band.runAction(cc.Sequence.create(cc.spawn(cc.moveTo(0.3, this.band_begin_position), cc.scaleTo(0.3, 0.3, 0.3)), cc.CallFunc.create(function() {
					this.showCarAnimation(1);
				}.bind(this))));
			} else {
				this.arry_sprite_cars[index].runAction(cc.fadeTo(0.2, 0));
			}
		}
    	
    	this.sprite_right_flag.runAction(cc.fadeTo(0.1, 0));
    },
    cleanScene:function(){
        releaseObj(this.animation_monkey);
        releaseObj(this.sprite_listener0);
        releaseObj(this.sprite_listener1);
        releaseObj(this.sprite_listener2);
        releaseObj(this.sprite_listener3);
    }
});

var CarChooseScene = cc.Scene.extend({
    ctor:function(){
        this._super();
    },
    onEnter:function () {
        this._super();
        var layer = new CarChooseLayer();
        this.addChild(layer);
    }
});

