
var CarIntroLayer = cc.Layer.extend({
	sprite_background:null,
    arry_carband_sequence:null,
    
    sprite_monkey:null,
    
    position_car_begin:null,
    position_car_end:null,
    
    sprite_band:null,
    sprite_name_c:null,
    sprite_name_e:null,
    sprite_car:null,
                                     
    sprite_listener0:null,
    sprite_listener1:null,
    sprite_listener2:null,
    sprite_listener3:null,
                                    
    star_ad:null,
    
    n_cur_step:null,
    
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        this._super();
        var self = this;
        cc.eventManager.addListener({
        	event: cc.EventListener.KEYBOARD,
        	onKeyReleased: function(keyCode, event) {
        		if (keyCode == cc.KEY.back) {
                    ddStopAllEffect();
                    self.cleanScene();
                    cc.director.popScene();
        		}
        		else if (keyCode == cc.KEY.menu) {

        		}
        	}}, this);
        
        var size = cc.winSize;
                                    
        this.initConfig();
                                      
        this.sprite_background = new cc.Sprite("res/game1/background.jpg");
        this.sprite_background.x = size.width / 2;
        this.sprite_background.y = size.height / 2;
        this.sprite_background.scaleX = widthRatio;
        this.addChild(this.sprite_background, 0);
                                     
        this.sprite_band = new cc.Sprite(getBackPath(this.arry_carband_sequence[this.n_cur_step]));
        this.sprite_band.x = size.width / 2 - 100;
        this.sprite_band.y = size.height / 2 - 40;
        this.sprite_band.opacity = 0;
        this.addChild(this.sprite_band, 1);
        
        this.sprite_name_c = new cc.Sprite(getCNamePath(this.arry_carband_sequence[this.n_cur_step]));
        this.sprite_name_c.x = size.width * 2 / 3 + 50;
        this.sprite_name_c.y = size.height / 4;
        this.sprite_name_c.opacity = 0;
        this.addChild(this.sprite_name_c, 2);
        
        this.sprite_name_e = new cc.Sprite(getENamePath(this.arry_carband_sequence[this.n_cur_step]));
        this.sprite_name_e.x = size.width / 2 - 100;
        this.sprite_name_e.y = size.height * 3 / 4 + 20;
        this.sprite_name_e.opacity = 0;
        this.addChild(this.sprite_name_e, 3);
        
        this.sprite_car = new cc.Sprite(getENamePath(this.arry_carband_sequence[this.n_cur_step]));
        this.sprite_car.setPosition(this.position_car_begin);
        this.addChild(this.sprite_car, 4);
        
        this.sprite_monkey = new cc.Sprite("res/game1/blind/1.png");
        this.sprite_monkey.x = 160;
        this.sprite_monkey.y = 120;
        this.addChild(this.sprite_monkey, 5);
        
        var arry_menu_item = [];
        var backItem = new cc.MenuItemImage(
        		"res/RetBtnNormal.png",
        		"res/ReturnBtnHigh.png",
            function () {
                ddStopAllEffect();
                self.cleanScene();
                cc.director.popScene();
        }, this);
        backItem.attr({
            x:isFullScreenDevice()?170:70,
            y: size.height - 70,
            anchorX: 0.5,
            anchorY: 0.5
        });
        arry_menu_item[0] = backItem;
                                     
        var menu_item_backward = new cc.MenuItemImage(
            "res/game1/backward.png",
            "res/game1/backward.png",
            function () {
            	this.pauseAllTarget();
                if (0 == this.n_cur_step) {
					this.n_cur_step = this.arry_carband_sequence.length - 1;
				} else{
					this.n_cur_step--;
				}
                this.reshuffleGame();
        }, this);
        menu_item_backward.attr({
            x: 120,
            y: size.height / 2,
            anchorX: 0.5,
            anchorY: 0.5
        });
        arry_menu_item[1] = menu_item_backward;
        
        var menu_item_forward = new cc.MenuItemImage(
        		"res/game1/forward.png",
        		"res/game1/forward.png",
        		function () {
        			this.pauseAllTarget();
        			if ((this.arry_carband_sequence.length - 1) == this.n_cur_step) {
        				this.n_cur_step = 0;
        			} else{
        				this.n_cur_step++;
        			}
        			this.reshuffleGame();
        		}, this);
        menu_item_forward.attr({
        	x: size.width - 120,
        	y: size.height / 2,
        	anchorX: 0.5,
        	anchorY: 0.5
        });
        arry_menu_item[2] = menu_item_forward;
                                     
        var menu = new cc.Menu(arry_menu_item);
        menu.x = 0;
        menu.y = 0;
        this.addChild(menu, 6);
                                    
        var sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
              
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                  
                if (cc.rectContainsPoint(rect, locationInNode)) {
                    self.checkTouchSprite(target);
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
                
            },
            onTouchEnded: function (touch, event) {
                
            }
        });

        this.sprite_listener0 = sprite_listener.clone();
        this.sprite_listener0.retain();
        this.sprite_listener1 = sprite_listener.clone();
        this.sprite_listener1.retain();
        this.sprite_listener2 = sprite_listener.clone();
        this.sprite_listener2.retain();
        this.sprite_listener3 = sprite_listener.clone();
        this.sprite_listener3.retain();
        
        this.showMonkeyAnimation(0);
                                    
        cc.eventManager.addListener(this.sprite_listener0, this.sprite_car);
        cc.eventManager.addListener(this.sprite_listener1, this.sprite_band);
        cc.eventManager.addListener(this.sprite_listener2, this.sprite_name_c);
        cc.eventManager.addListener(this.sprite_listener3, this.sprite_name_e);
                                    
        this.reshuffleGame();
                                    
        if(ARRY_AD_IN && ARRY_AD_IN.length){
            if(AD_ENABLE){
                showStarAd(this, this.star_ad, cc.p(cc.winSize.width - 80, cc.winSize.height - 150));
            }
        }
        
        return true;
    },
                                     
    reshuffleGame:function(){
//        this.n_cur_step = this.n_cur_step % 16;
    	ddStopAllEffect();
        this.sprite_car.setPosition(this.position_car_begin);
        this.sprite_car.scale = 1;
        this.sprite_car.setTexture(getCarPath(this.arry_carband_sequence[this.n_cur_step]));
        
        this.sprite_band.opacity = 0;
        this.sprite_band.setTexture(getNormalPath(this.arry_carband_sequence[this.n_cur_step]));
        
        this.sprite_name_c.opacity = 0;
        this.sprite_name_c.setTexture(getCNamePath(this.arry_carband_sequence[this.n_cur_step]));
        
        this.sprite_name_e.opacity = 0;
        this.sprite_name_e.setTexture(getENamePath(this.arry_carband_sequence[this.n_cur_step]));
        
        ddPlayEffect('', getCSoundPath(this.arry_carband_sequence[this.n_cur_step]), false);
        
        this.showCarAnimation();
        
        this.sprite_band.runAction(cc.fadeTo(0.3, 255));
        this.sprite_name_c.runAction(cc.fadeTo(0.3, 255));
        this.sprite_name_e.runAction(cc.Sequence.create(cc.fadeTo(0.3, 255), cc.CallFunc.create(function() {
			this.resumeAllTarget();
		}.bind(this))));
    },
    initConfig:function(){
        var size = cc.winSize;
        this.n_cur_step = 0;
        
        this.position_car_begin = cc.p(size.width + 200, size.height);
        this.position_car_end = cc.p(size.width * 2 / 3 + 40, size.height * 2 / 3 + 20);
        
        this.arry_carband_sequence = getCarArray();
        this.arry_carband_sequence.reshuffle();
    },
    
    pauseAllTarget:function(){
        cc.eventManager.setEnabled(false);
/*        cc.eventManager.removeListener(this.sprite_listener0);
        cc.eventManager.removeListener(this.sprite_listener1);
        cc.eventManager.removeListener(this.sprite_listener2);
        cc.eventManager.removeListener(this.sprite_listener3);*/
    },
    resumeAllTarget:function(){
        cc.eventManager.setEnabled(true);
/*        cc.eventManager.addListener(this.sprite_listener0, this.sprite_car);
        cc.eventManager.addListener(this.sprite_listener1, this.sprite_band);
        cc.eventManager.addListener(this.sprite_listener2, this.sprite_name_c);
        cc.eventManager.addListener(this.sprite_listener3, this.sprite_name_e);*/
    },
    checkTouchSprite:function(sprite_target){
    	if (sprite_target == this.sprite_car) {
    		ddStopAllEffect();
			ddPlayEffect('', getCSoundPath(this.arry_carband_sequence[this.n_cur_step]), false);
			this.sprite_car.stopAllActions();
			this.sprite_car.scale = 0.8;
			this.sprite_car.runAction(cc.Sequence.create(cc.ScaleTo(0.15, 0.6, 0.6), cc.ScaleTo(0.15, 0.8, 0.8), cc.ScaleTo(0.15, 0.6, 0.6), cc.ScaleTo(0.15, 0.8, 0.8)));
			this.showMonkeyAnimation(1);
    	} else if(sprite_target == this.sprite_band){
    		this.showMonkeyAnimation(1);
    		ddPlayEffect('', getCSoundPath(this.arry_carband_sequence[this.n_cur_step]), false);
    	} else if(sprite_target == this.sprite_name_c){
    		this.showMonkeyAnimation(1);
    		ddPlayEffect('', getCSoundPath(this.arry_carband_sequence[this.n_cur_step]), false);
    	} else if(sprite_target == this.sprite_name_e){
    		this.showMonkeyAnimation(1);
    		ddPlayEffect('', getESoundPath(this.arry_carband_sequence[this.n_cur_step]), false);
		}
    },
    showMonkeyAnimation:function(step){
    	switch (step) {
		case 0:
		{
			this.sprite_monkey.stopAllActions();
			var animation_blink = new cc.Animation.create();
			animation_blink.setDelayPerUnit(0.05);
			animation_blink.setRestoreOriginalFrame(false);
			for(var n_index = 0; n_index < 18; ++n_index){
				animation_blink.addSpriteFrameWithFile("res/game1/blind/" + (n_index + 1) + ".png");
			}
			this.sprite_monkey.runAction(cc.RepeatForever.create(new cc.Animate(animation_blink)));
			break;
		}
		case 1:
		{
			this.sprite_monkey.stopAllActions();
			var animation_wave = new cc.Animation.create();
			animation_wave.setDelayPerUnit(0.05);
			animation_wave.setRestoreOriginalFrame(false);
			for(var n_index = 0; n_index < 17; ++n_index){
				animation_wave.addSpriteFrameWithFile("res/game1/wave/" + (n_index + 1) + ".png");
			}
			this.sprite_monkey.runAction(cc.Sequence.create(new cc.Animate(animation_wave), cc.CallFunc.create(function() {
				this.showMonkeyAnimation(0);
			}.bind(this))));
			break;
		}
		default:
			break;
		}
    },
    showCarAnimation:function(){
    	this.sprite_car.opacity = 0;
    	this.sprite_car.stopAllActions();
    	this.sprite_car.x = this.position_car_begin.x;
    	this.sprite_car.y = this.position_car_begin.y;
    	this.sprite_car.runAction(cc.spawn(cc.moveTo(0.4, this.position_car_end).easing(cc.easeInOut(3)), cc.fadeTo(0.4, 255), cc.scaleTo(0.4, 0.9, 0.9)));
    },
    cleanScene:function(){
        releaseObj(this.sprite_listener0);
        releaseObj(this.sprite_listener1);
        releaseObj(this.sprite_listener2);
        releaseObj(this.sprite_listener3);
    }
});

var CarIntroScene = cc.Scene.extend({
    ctor:function(){
        this._super();
    },
    onEnter:function () {
        this._super();
        var layer = new CarIntroLayer();
        this.addChild(layer);
    }
});

