var GInMoveScene = true;
var MovieLayer = cc.Layer.extend({
    video_player:null,
    ctor:function () {
        this._super();

        var size = cc.winSize;

        this.listener = registerTouchEventOneByOne(this,true);
        cc.eventManager.addCustomListener(cc.game.EVENT_SHOW, function(){cc.log("回到游戏中"); if(GInMoveScene) cc.director.runScene(new MovieScene());});

        if(isPad()){
            this.video_player = new ccui.VideoPlayer("res/movie/movie852.mp4");
            this.video_player.setContentSize(cc.size(1136, 852));
        }else{
            this.video_player = new ccui.VideoPlayer("res/movie/movie640.mp4");
            this.video_player.setContentSize(cc.size(winWidth(), winWidth() / 1136 * 640));

        }
        this.video_player.setGlobalZOrder(1);
        this.video_player.x = size.width / 2;
        this.video_player.y = size.height / 2;
        this.video_player.setKeepAspectRatioEnabled(true);
        this.addChild(this.video_player, 2);


        this.video_player.setEventListener(ccui.VideoPlayer.EventType.COMPLETED, function(sender){
            this.scheduleOnce(function() {
                GInMoveScene = false;
                cc.director.runScene(new GameSelectScene());
            }, 0.2);
        });

        this.video_player.play();

        return true;
    },
        onTouchBegan: function (touch, event) {
            return true;
        },
        onTouchMoved: function(touch,event){

        },
        onTouchEnded: function(touch,event){

        }
});

var MovieScene = cc.Scene.extend({
    onEnter:function () {
        this._super();

        var layer = new MovieLayer();
        this.addChild(layer);
    }
});